def fn import_slc% (file$)
rem import slc style levels (xml)
rem return 1 if ok, 0 if not
rem (space) = ground
rem . = store
rem $ = object
rem * = object on store
rem @ = mover
rem + = mover on store
rem # = wall
rem
local chan%,lp%,a$,maxl%,maxcol%,lwidth%,lheight%,must_rotate%
  maxpuzzle%=500
  chan%=fop_in(file$)
  if chan%<0:return 0
  new_level%=0
  grid_number%=0
  dim grids%(maxpuzzle%,50,50)
  dim grid_sizes%(maxpuzzle%,2)
  dim men%(maxpuzzle%,2)
  rep lp%
    if eof(#chan%): exit lp%
    a$=gline$(#chan%)
    if "<Level Id=" instr a$
       get_level_info a$
       if lwidth%<=0 or lheight%<=0 or lwidth%>max_cols%  or  (lheight% > max_lines% and lheight% > max_cols%)
	   next lp%
       endif
       if  lheight% > max_lines% and lwidth% > max_lines%
	  next lp%	: rem can't even rotate
       endif
       get_level_data chan%
       if lheight%>max_lines%:rotate_grid grid_number%-1
    else
      if "MaxWidth=" instr a$
	maxcol%=extract_info% (a$,'MaxWidth="')
	maxl%=extract_info%(a$,'MaxHeight="')
	if maxl%<maxcol%:maxl%=maxcol%
	dim grids%(maxpuzzle%,maxl%,maxl%)   : rem too much space, but some puzzles might have to be rotated
      endif
    end if
    if eof(#chan%): exit lp%
    if grid_number%>maxpuzzle%:exit lp%
  end rep lp%
  close#chan%
  maxpuzzle%=grid_number%
  level$=levelprim$&maxpuzzle%&")"
  return 1
end def import_slc%
:
def proc get_level_data (chan%, xs%)
rem gets data on one level
rem chan%= (local) from caller
local lp%,b$,cd,inside%
   grid_sizes%(grid_number%,0)=lheight%
   grid_sizes%(grid_number%,1)=lwidth%
   for lp% =1 to lheight%
     if eof(#chan%):exit lp%
     a$=gline$(#chan%)
     a$=strip_spaces$(a$)
     if "</Level>" instr a$:return 0		: rem ooops?
     if a$(1 to 3)="<L>"
       inside%=0
       for lp2%=4 to 4+lwidth%
	 b$=a$(lp2%)
	 cd=code(b$)
	 select on cd
	   = 32:			rem space , do nothing (stays 0)
	      if inside%:grids%(grid_number%,lp%,lp2%-3)=8
	   = 35:			rem # wall
	      grids%(grid_number%,lp%,lp2%-3)=2
	      inside%=1
	   = 36:			rem $ object
	      grids%(grid_number%,lp%,lp2%-3)=4
	   = 42:			rem * object on target
	      grids%(grid_number%,lp%,lp2%-3)=20
	   = 43:			rem + man (on target)
	      grids%(grid_number%,lp%,lp2%-3)=16
	      men% (grid_number%,0)=lp2%-3
	      men%(grid_number%,1)=lp%
	   = 46:			rem . target
	      grids%(grid_number%,lp%,lp2%-3)=16
	   = 64:			rem @ man
	      men% (grid_number%,0)=lp2%-3
	      men%(grid_number%,1)=lp%
	      grids%(grid_number%,lp%,lp2%-3)=8
	   = remainder: exit lp2%
	 end select
       end for lp2%
     endif
   end for lp%
   a$=gline$(#chan%)
   if "</Level>" instr a$
      grid_number%=grid_number%+1
   endif
end def get_level_data
:
def proc get_level_info
rem lwidth and lheight are variables from caller
local t%,b$
  lwidth%=extract_info% (a$,'Width="')
  lheight%=extract_info%(a$,'Height="')
end def get_level_info
:
def fn extract_info% (a$,info$)
rem gets a number from the string
local t%,b$
  t%=info$ instr a$
  if t%=0:return
  b$=a$(t%+len(info$) to)
  t%='"' instr b$
  if t%=0:return
  b$=b$(to t%)
  t%=b$
  return t%
end def extract_info%
:
